<?php
/*
 * A CCViews global-scope function API.
 * 
 * Copyright 2008-2009, Peter Rowntree.
 * http://www.hdyn.com/mail/contact.php?addr=pr
 *
 * License: you may not use this file except in compliance with
 * the Apache License, Version 2.0, a copy of which you may obtain at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * needs PHP 5.
 * URL syntax: holder.php?d0=a,b;c,d&d1=p,q,r;s,t...&dn=x,y,x&trace
 */

require_once "ccViews.php";
$g_viewsOb;
/**
 * Creates a global CCViews object, $g_viewsOb
 *
 * @param array $defaultsKVArr an assoc array specifying defaults for unspecified $_GET's
 * @param int $maxDepth
 * @param string $viewFileExtension
 * @return CCViews object $g_viewsOb
 */
function createViewsObject($defaultsKVArr=null,$maxDepth=10,$viewFileExtension=".thtml")
{
	global $g_viewsOb;
	try
	{
		$g_viewsOb=CCViews::create($defaultsKVArr,$maxDepth,$viewFileExtension);
	}
	catch(Exception $e)
	{
		exit("ERROR: ".$e->getMessage());
	}
	return $g_viewsOb;
}

function getViewsObject()
{
	global $g_viewsOb;
	return $g_viewsOb;
}

function showTrace()
{
	global $g_viewsOb;
	$g_viewsOb->showTrace();
	return $g_viewsOb;
}

function viewByIndex($i)
{
	global $g_viewsOb;
	$g_viewsOb->viewByIndex($i);
	return $g_viewsOb;
}

function viewByName($viewName)
{
	global $g_viewsOb;
	$g_viewsOb->viewByName($viewName);
	return $g_viewsOb;
}

function gotView($viewName)
{
	global $g_viewsOb;
	return $g_viewsOb->gotView($viewName);
}

function vSet($k,$v)
{
	global $g_viewsOb;
	$g_viewsOb->set($k,$v);
	return $g_viewsOb;
}

function vGet($k)
{
	global $g_viewsOb;
	return $g_viewsOb->get($k);
}

?>