<?php
/*
 * CCViewsViewer version 1.1.0
 * 
 * Copyright 2008, Peter Rowntree.
 * http://www.hdyn.com/mail/contact.php?addr=pr
 *
 * License: you may not use this file except in compliance with
 * the Apache License, Version 2.0, a copy of which you may obtain at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * needs PHP 5.
 */

require_once "ccViewsServer.php";
if(isset($_GET["v"]))
	$g_viewsOb->setView($_GET["v"]);
$g_alwaysDoTrace=true;
$g_output=array();
$arr=makeFileArray("views/");
if($arr !== false)
{
	$g_linkPrefix="ccViewsViewer.php";
	arrayToHTML("views",$arr);
	$g_output=implode("\n",$g_output);
}
$g_dt=isset($_COOKIE) && isset($_COOKIE["dt"]) ? $_COOKIE["dt"] : 3;

function arrayToHTML($label,&$arr)
{
	global $g_output,$g_linkPrefix;
	$g_output[]="<div><span>$label</span>";
	foreach($arr as $k=>$v)
	{
		if(is_array($v))
			arrayToHTML($k,$v);
		else
			$g_output[]="<p><a href=\"".$g_linkPrefix
				."?v=".rawurlencode($v)
				."\">".htmlspecialchars($k)."</a></p>";
	}
	$g_output[]="</div>";
}

function buildCheckboxes()
{
	global $g_dt;
	$flag=1;
	foreach(array("description","source","appearance") as $x)
	{
		echo "<input type='checkbox' onclick='sdtff(this,",$flag,")'",
			($g_dt&$flag) != 0 ?  " checked='checked'" : "",
			"/>$x";
		$flag<<=1;
	}
}

?>
<!DOCTYPE html 
	PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title>CCViews Viewer</title>
<?php
	setCSS("css/core1.css","css/jsWarn.css");
	$g_viewsOb->buildCSSImports();
?>
	<style type="text/css">
		.viewer{font-family:monospace;font-size:12px;}
		table.viewer td{vertical-align: top;}
		.nest{margin-left:-8px;}
		.nest div{margin:2px;margin-left:8px;margin-bottom:2px;
			background-color:#ddd;border:1px solid #aaa;}
		.nest a{display:block;margin:2px;background-color:#eee;text-decoration:none;}
		.nest a:hover{background-color:#fed;}
		.nest p{margin:1px;margin-left:8px;}
		.nest span{background-color:#ced;padding-left:4px;padding-right:8px;
			border-right:1px solid #aaa;border-bottom:1px solid #aaa;}
		pre.src{position:relative;margin:2px;
			text-align:left;background-color:#eec;}
		.gp1{ position:relative;margin:2px;}
		.info{background-color:#ffc;}
		.radios{background-color:#efc;}
		#desc{background-color:#eef;display:<?php echo ($g_dt&1)!=0 ? "block" : "none"; ?>}
		#src{display:<?php echo ($g_dt&2)!=0 ? "block" : "none"; ?>}
		#appearance{border:1px solid #aaa;display:<?php echo ($g_dt&4)!=0 || !isset($_GET["v"]) ? "block" : "none"; ?>}
	</style>
	<script type='text/javascript'>
		var g_dt=<?php echo $g_dt; ?>;
		function sdtff(ob,inFlag)
		{
			var setIt=ob.checked;
			if(setIt)
				g_dt|=inFlag;
			else
				g_dt&=~inFlag;
			var ids=["desc","src","appearance"];
			var flag=1;
			for(var id in ids)
			{
				document.getElementById(ids[id]).style.display = (flag&g_dt)!=0 ? "block" : "none";
				flag<<=1;
			}
   		document.cookie="dt="+g_dt;
		}
	</script>
</head>
<body class='viewer'>
	<?php $g_viewsOb->viewByName("jsWarn"); ?>
	<table cellpadding='2px' cellspacing='2px' class='viewer'>
	  <tr>
	    <td><div class='nest'><?php echo $g_output; ?></div></td>
	    <td class=''>
	    	<div class='gp1 info'><?php $g_viewsOb->reportDepends(); ?></div>
				<div class='gp1 radios'>show: <?php buildCheckboxes(); ?></div>
				<pre class='desc' id='desc'><?php if(isset($_GET["v"])) $g_viewsOb->viewDesc(); ?></pre>
				<pre class='src' id='src'><?php if(isset($_GET["v"])) $g_viewsOb->viewSrc(); ?></pre>
				<div class='gp1' id='appearance'><?php if(isset($_GET["v"])) $g_viewsOb->viewByName($_GET["v"]); else echo "&lt;&lt; &mdash; select a view &mdash; &lt;&lt;&lt;"; ?></div>
			</td>
	  </tr>
  </table>
</body>
</html>