/*
 * Copyright 2003-2008, Peter Rowntree.
 * http://www.hdyn.com/mail/contact.php?addr=pr
 * License: you may not use this file except in compliance with
 * the Apache License, Version 2.0, a copy of which you may obtain at
 *   http://www.apache.org/licenses/LICENSE-2.0
 */
 
var g_msHTTPStr=null;
var g_XMLErrorReporter=null;

function setXMLErrorReporter(errProc)
{
	g_XMLErrorReporter=errProc;
}

function reportXMLError(err)
{
	if(g_XMLErrorReporter == null)
		alert(err);
	else
		g_XMLErrorReporter(err);
}

function XMLRequest(req,doneProc)
{
	this.stateChange=function()
	{
		switch(req.readyState)
		{
			case 4:
				if(doneProc == null)
					return;
				if(typeof doneProc == 'function')
					doneProc(req);
				else
					doneProc.done(req);
				break;
		}
	}
}

function detectMSObjects(arr,errStr)
{ 
	var ob;
	for(var i=0; i < arr.length; i++)
	{
		try
		{
			ob=new ActiveXObject(arr[i]);
			return arr[i];
		}
		catch(e)
		{ }
	}
	if(errStr != null)
		reportXMLError(errStr);
	return null;
}

function buildMSHTTPStr()
{
	if(g_msHTTPStr != null)
		return true;
	var arr=new Array("Msxml2.XMLHTTP","Microsoft.XMLHTTP");
	g_msHTTPStr=detectMSObjects(arr,"Unable to create an XMLHTTP request object");
	return g_msHTTPStr != null;
}

function createRequest(endProc)
{
	var async=endProc != null;
	var ro=null;
	var req=null;
	if(typeof XMLHttpRequest != "undefined")
	{
		req=new XMLHttpRequest();
		if(async)
		{
			ro=new XMLRequest(req,endProc);
			req.onreadystatechange=ro.stateChange;
		}
		return req;
	}
	if(typeof window.ActiveXObject == 'undefined')
		return null;
	if(g_msHTTPStr == null && !buildMSHTTPStr())
		return null;
	req=new ActiveXObject(g_msHTTPStr);
	if(async)
	{
		ro=new XMLRequest(req,endProc);
		req.onreadystatechange=ro.stateChange;
	}
	return req;
}

function sendXML(xml,uri,endProc)
{
	var method=(arguments.length < 4 ? "POST" : arguments[3]);
	var user=(arguments.length < 5 ? null : arguments[4]);
	var pass=(arguments.length < 6 ? null : arguments[5]);
	var req=null;
	try
	{
		req=createRequest(endProc);
		if(req == null)
			throw "Sorry, your browser lacks the ability to run this web application.";
		var async=endProc != null;
		req.open(method,uri,async,user,pass);  // method,url,async,user,password 
		req.setRequestHeader("Content-Type", "text/xml; charset=utf-8");
		req.send(xml);
	}
	catch(e)
	{
		reportXMLError(typeof e.message == "undefined" ? e : e.message);
		return null;
	}
	return req; //usually only useful if !async
}


//async calls can test for existence of this funtion to discover if 
//the rest of the js has unloaded under them
//this version expects responseText, not responseXML
function testError(resp)
{
	if(resp == null)
		throw "no response!";
	var errStr="";
	var lf="<br/>";
	if(resp.status != 200)
	{
		errStr+=resp.status+" "+resp.statusText+lf;
		throw errStr;
	}
	if(resp.responseText == null)  //allow ""
		throw "expected xml responseText, got null"+lf;
	switch(resp.responseText.substr(0,6))
	{
		case "ERROR:":
			throw resp.responseText;
	}
}
	