/*
 * Copyright 2008-2009, Peter Rowntree.
 * http://www.hdyn.com/mail/contact.php?addr=pr
 * License: you may not use this file except in compliance with
 * the Apache License, Version 2.0, a copy of which you may obtain at
 *   http://www.apache.org/licenses/LICENSE-2.0
 */

//one preloader can be used everywhere:
var g_preloader=new ImagePreloader("images/",false);
//e.g:
g_preloader.preload(["sally.gif","fred.jpg","subfolder/frank.png"]);

/*
usage:
	define a global, e.g var g_ip=new ImagePreloader("images/",true);
	imgsPath must end in "/", and that folder must contain the file "trans.gif" if filterPNGs is true
	call the member function preload() with an array argument,
		e.g. g_ip.preload(["sally.gif","fred.jpg","subfolder/frank.png"]);
*/
function ImagePreloader(imgsPath,filterPNGs) //uses closures
{
	this.arr=[];
	this.preload=function(arr)
	{
		var img;
		for(var i=0; i < arr.length; i++)
		{
			img=document.createElement('img');
			this.setImgSrc(img,imgsPath+arr[i]);
			this.arr.push(img);
		}
	}
	this.setImgSrc=function(img,src)
	{
		if(filterPNGs && typeof img.style.filter != 'undefined' && isPNG(src))
		{
			img.src=imgsPath+"trans.gif";
			img.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"
				+src+"',sizingMethod='scale')";
		}
		else
			img.src=src;
	}
}

function isPNG(src)
{
	var arr=src.split(".");
	return arr[arr.length-1].toLowerCase() == "png";
}